/* grgray.f -- translated by f2c (version 20090411).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "pgplot.h"

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;

/* *GRGRAY -- gray-scale map of a 2D data array */
/* + */
/* Subroutine */ void grgray_(real *a, integer *idim, integer *jdim, integer *
	i1, integer *i2, integer *j1, integer *j2, real *fg, real *bg, real *
	pa, integer *minind, integer *maxind, integer *mode)
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1;
    real r__1, r__2, r__3;

    /* Local variables */
    static integer i__;
    static real a0, a1, cb0, cb1, cg0, cg1, cr0, cr1;


/* This is a device-dependent support routine for PGGRAY. */

/* Draw gray-scale map of an array in current window. Array */
/* values between FG and BG are shaded in gray levels determined */
/* by linear interpolation. FG may be either less than or greater */
/* than BG.  Array values outside the range FG to BG are */
/* shaded black or white as appropriate. */

/* GRGRAY uses GRIMG0 on devices with enough color indices available. */
/* Note that it changes the color table to gray-scale. */
/* Otherwise in does a random dither with GRIMG3. */

/* Arguments: */
/*  A      (input)  : the array to be plotted. */
/*  IDIM   (input)  : the first dimension of array A. */
/*  JDIM   (input)  : the second dimension of array A. */
/*  I1, I2 (input)  : the inclusive range of the first index */
/*                    (I) to be plotted. */
/*  J1, J2 (input)  : the inclusive range of the second */
/*                    index (J) to be plotted. */
/*  FG     (input)  : the array value which is to appear in */
/*                    foreground color. */
/*  BG     (input)  : the array value which is to appear in */
/*                    background color. */
/*  PA     (input)  : transformation matrix between array grid and */
/*                    device coordinates (see GRCONT). */
/*  MODE   (input)  : transfer function. */
/* -- */
/* 12-Dec-1986 - Speed up plotting [J. Biretta]. */
/*  3-Apr-1987 - Add special code for /PS, /VPS, /GR. */
/*  2-Sep-1987 - Adapted from PGGRAY [TJP]. */
/*  1-Dec-1988 - Put random-number generator inline [TJP]. */
/*  3-Apr-1989 - Use "line of pixels" primitive where available [TJP]. */
/*  6-Sep-1989 - Changes for standard Fortran-77 [TJP]. */
/* 19-Jan-1990 - Add special code for /CPS, /VCPS [DLM] */
/*  3-Sep-1992 - Add special code for NULL device [TJP]. */
/* 25-Nov-1992 - Add special code for /NEXT [AFT]. */
/* 17-Mar-1994 - Scale in device coordinates [TJP]. */
/* 31-Aug-1994 - use GRIMG0 when appropriate [TJP]. */
/*  7-Sep-1994 - speed up random dither [TJP]. */
/*  8-Feb-1995 - use color ramp based on color indices 0 and 1 [TJP]. */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */


/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */


/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

/* N.B. Arguments are assumed to be valid (checked by PGGRAY). */

/* Use GRIMG0 if this an appropriate device; first initialize the */
/* color table to a linear ramp between the colors assigned to color */
/* indices 0 and 1. */

    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1;
    a -= a_offset;
    --pa;

    /* Function Body */
    if (*(unsigned char *)&grcm01_.grgcap[(grcm00_.grcide - 1) * 11 + 6] != 
	    'N' && *maxind - *minind > 15) {
	grqcr_(&c__0, &cr0, &cg0, &cb0);
	grqcr_(&c__1, &cr1, &cg1, &cb1);
	i__1 = *maxind;
	for (i__ = *minind; i__ <= i__1; ++i__) {
	    a0 = (real) (i__ - *minind) / (real) (*maxind - *minind);
	    a1 = 1.f - a0;
	    r__1 = a0 * cr0 + a1 * cr1;
	    r__2 = a0 * cg0 + a1 * cg1;
	    r__3 = a0 * cb0 + a1 * cb1;
	    grscr_(&i__, &r__1, &r__2, &r__3);
/* L5: */
	}
	grimg0_(&a[a_offset], idim, jdim, i1, i2, j1, j2, fg, bg, &pa[1], 
		minind, maxind, mode);
	return;

/* Otherwise use random dither in current color index. */

    } else {
	grimg3_(&a[a_offset], idim, jdim, i1, i2, j1, j2, fg, bg, &pa[1], 
		mode);
    }
/* ----------------------------------------------------------------------- */
} /* grgray_ */

