#include "pgplot.h"

void GRSCI(int *IC) {
	int COLOR, IC1, IC2, NBUF,LCHR;
	float RBUF[6];
	char CHR;
	int IFUNC;
	int cgrcide;

/*
 * Error if no workstation is open.
 */
	if (grcm00_.grcide < 1) {
		GRWARN("GRSCI - no graphics device is active.", 37);
		return;
	}
	cgrcide = grcm00_.grcide - 1;

/*
 * Use color index 1 if out of range.
 */
	IC1 = grcm00_.grmnci[cgrcide];
	IC2 = grcm00_.grmxci[cgrcide];
	COLOR = *IC;
	if (COLOR < IC1 || COLOR > IC2) COLOR = 1;

/*
 * If no change to color index is requested, take no action.
 */
	if (COLOR == grcm00_.grccol[cgrcide]) return;

/*
 * If the workstation is in "picture open" state, send command to
 * driver.
 */
	if (grcm00_.grpltd[cgrcide]) {
		RBUF[0] = COLOR;
		IFUNC = 15;
		GREXEC(&grcm00_.grgtyp, &IFUNC, RBUF, &NBUF, &CHR, &LCHR, 1);
	}

/*
 * Set the current color index.
 */
	grcm00_.grccol[cgrcide] = COLOR;
}

