/*
C*GRSLCT -- select active output device
C+
      SUBROUTINE GRSLCT (IDENT)
C
C GRPCKG: Check that IDENT is a valid plot identifier, and select the
C corresponding plot as the current plot. All subsequent plotting will
C be directed to this device until the assignment is changed by another
C call to GRSLCT.
C
C Argument:
C
C IDENT (input, integer): the identifier of the plot to be selected, as
C       returned by GROPEN.
C--
C (1-Feb-1983)
C  5-Aug-1986 - add GREXEC support [AFT].
C  4-Jun-1987 - skip action if no change in ID [TJP].
C 26-Nov-1990 - [TJP].
C-----------------------------------------------------------------------
*/

#include "pgplot.h"
#define GRIMAX 8

void GRSLCT(int *IDENT) {
	float RBUF[6];
	int NBUF, LCHR;
	char CHR;
	int cident = *IDENT - 1;
	int ifunc = 8;

	if ((*IDENT <= 0) || (*IDENT > GRIMAX) || (grcm00_.grstat[cident] == 0)) {
		GRWARN("GRSLCT - invalid plot identifier.", 33);
	} else if (*IDENT == grcm00_.grcide) {
		grcm00_.grgtyp = grcm00_.grtype[cident];
		return;
	} else {
		grcm00_.grcide = *IDENT;
		grcm00_.grgtyp = grcm00_.grtype[cident];
		RBUF[0] = grcm00_.grcide;
		RBUF[1] = grcm00_.grunit[grcm00_.grcide - 1];
		NBUF = 2;
		GREXEC(&grcm00_.grgtyp, &ifunc, RBUF, &NBUF, &CHR, &LCHR, 1);
	}
}
