/*
C
      LOGICAL FUNCTION PGNOTO (RTN)
      CHARACTER*(*) RTN
C
C PGPLOT (internal routine): Test whether a PGPLOT device is open and
C print a message if not. Usage:
C     LOGICAL PGNOTO
C     IF (PGNOTO('routine')) RETURN
C
C Arguments:
C
C RTN (input, character): routine name to be include in message.
C
C Returns:
C     .TRUE. if PGPLOT is not open.
C--
C 11-Nov-1994
C 21-Dec-1995 - revised for multiple devices.
C-----------------------------------------------------------------------
*/

#include <string.h>
#include <stdio.h>
#include "pgplot.h"

#define PGMAXD 8
#define TRUE 1
#define FALSE 0

int PGNOTO(char *RTN, int maxlen) {
	char TEXT[81];
	int rv;
	
	PGINIT();
	rv = FALSE;

	if ((pgplt1_.pgid < 1) || (pgplt1_.pgid > PGMAXD)) {
		rv = TRUE;
		snprintf(TEXT, maxlen, "%s", RTN);
		strcat(TEXT, ": no graphics device has been selected");
		GRWARN(TEXT, strlen(TEXT));
	} else if (pgplt1_.pgdevs[pgplt1_.pgid - 1] != 1) {
		rv = TRUE;
		snprintf(TEXT, maxlen, "%s", RTN);
		strcat(TEXT, ": selected graphics device is not open");
		GRWARN(TEXT, strlen(TEXT));
	}
	
	return(rv);
}
